VERSION 5.00
Begin VB.Form fTest 
   Caption         =   "Fast WordCounting (Dictionary-Comparison)"
   ClientHeight    =   4245
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   6585
   LinkTopic       =   "Form1"
   ScaleHeight     =   4245
   ScaleWidth      =   6585
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CheckBox chkCompareMode 
      Caption         =   "Case-InSensitive"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   720
      Width           =   1695
   End
   Begin VB.CommandButton cmdRun 
      Caption         =   "Run Test"
      Height          =   435
      Left            =   240
      TabIndex        =   1
      Top             =   180
      Width           =   1515
   End
   Begin VB.ListBox lstWordsCounts 
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3840
      Left            =   2340
      TabIndex        =   0
      Top             =   180
      Width           =   3855
   End
End
Attribute VB_Name = "fTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'this WordScan-Demo requires the '100.txt'-file (Shakespeare-Collection) in its App.Path...
'this file is downloadable here: http://www.gutenberg.org/files/100/

Private Declare Function QueryPerformanceFrequency& Lib "kernel32" (x@)
Private Declare Function QueryPerformanceCounter& Lib "kernel32" (x@)

Private Type SAFEARRAY1D
  cDims As Integer
  fFeatures As Integer
  cbElements As Long
  cLocks As Long
  pvData As Long
  cElements1D As Long
  lLbound1D As Long
End Type
Private Declare Sub BindArray Lib "kernel32" Alias "RtlMoveMemory" (PArr() As Any, pSrc&, Optional ByVal CB& = 4)
Private Declare Sub ReleaseArray Lib "kernel32" Alias "RtlMoveMemory" (PArr() As Any, Optional pSrc& = 0, Optional ByVal CB& = 4)

'Below you can just comment the WD-VariableType in, which you plan to test
'(this is the only place in the DemoCode, where such a Type-Switch is needed)
Private WD As New cHashD
'Private WD As New clsTrickHashTable
'Private WD As New Dictionary
 
Private Sub cmdRun_Click()
  AutoRedraw = True: Cls
  Dim B() As Byte, WordCountTotal As Long, T@, i, Keys, Items
  
  Open App.Path & "\100.txt" For Binary As #1
    ReDim B(LOF(1) - 1): Get #1, , B
  Close #1
  
  WD.RemoveAll
  WD.CompareMode = chkCompareMode
  
  T = msTimer
    ParseWords B, WordCountTotal ', lstBooks.ListIndex
  Print String(6, vbLf); "     "; TypeName(WD); ":"; vbLf
  Print "     Words Total:"; WordCountTotal
  Print "     Unique Words:"; WD.Count; vbLf
  Print "     Timing:"; msTimer - T; "ms"
  
  lstWordsCounts.Visible = False: lstWordsCounts.Clear
    Keys = WD.Keys
    Items = WD.Items
    For i = 0 To WD.Count - 1
      lstWordsCounts.AddItem Keys(i) & " (" & Items(i) & ")"
    Next i
  lstWordsCounts.Visible = True
End Sub
 
Private Sub ParseWords(B() As Byte, WordCountTotal As Long)
Dim i&, j&, BookNr&, WordLen&, Idx, W$, saW As SAFEARRAY1D
Dim WCounts() As Long, WB() As Integer
 
  W = Space$(512) 'now span a safearray over W ... for fast Wchar-access per WB()
      saW.cDims = 1
      saW.cbElements = 2
      saW.lLbound1D = -2
      saW.cElements1D = Len(W) + 2
      saW.pvData = StrPtr(W) - 4
  BindArray WB, VarPtr(saW) 'now we bind WB() -> W
    
  WordCountTotal = 0 'reset the WordTotal-Counter
  WB(-2) = 0 'set the initial StrLenB to zero
 
  ReDim WCounts(8192)

  For i = 0 To UBound(B)
    Select Case B(i)
      Case 39, 65 To 90, 97 To 122 'add the char into our current Single-Word Array
        WB(WordLen) = B(i): WordLen = WordLen + 1
      Case Else 'it's whitespace
        If WordLen > 0 Then 'WordLen is only > 0 on the first (new) WhiteSpace-Char, follwing a word,
          WB(-2) = WordLen + WordLen 'so now we adjust the LenB-Field of the "array-mapped BString"
          WB(WordLen) = 0  'and set a terminating zero-WChar
        
          If WD.Exists(W) Then  'Word does already exist in the dictionary
            Idx = WD.Item(W)
          Else
            Idx = WD.Count 'so we assign the Idx-Variable to the next free index-slot
            WD.Add W, Idx
            If Idx > UBound(WCounts) Then ReDim Preserve WCounts(2 * Idx)
          End If
        
          WCounts(Idx) = WCounts(Idx) + 1
          WordCountTotal = WordCountTotal + 1
        End If
        WordLen = 0
    End Select
  Next i
  
  saW.pvData = 0: saW.cElements1D = 0
  ReleaseArray WB 'release the "WB()-> W" safearray-binding

  Dim Keys: Keys = WD.Keys
  For i = 0 To WD.Count - 1: WD.Item(Keys(i)) = WCounts(i): Next 'copy the Counts over
End Sub
 
Private Function msTimer@()
Dim x@, Frq@
  QueryPerformanceFrequency Frq
  If QueryPerformanceCounter(x) Then msTimer = CCur(x / Frq) * 1000
End Function
 
